#include <stdlib.h>
#include <stdio.h>

typedef struct _price_line {
  float price;
  char *line;
} price_line;

void main(int argc, char **argv);

void main(int argc, char **argv)
{
int i = 0, 
    j = 0, 
    lines = 0, 
    top_n = 20;
float price, ftemp;
price_line *list;
char line[256], *ctemp;
FILE *pricelist = NULL;

/* for(i=0; i < argc; i++)
  fprintf(stderr,"argv[%d]: |%s|\n",i,argv[i]); */

if(argc < 3)
  {
    fprintf(stderr,
	    "usage: %s pricelist `cat pricelist | wc -l` [top_n]\n",
	    argv[0]);
    exit(1);
  }

pricelist = fopen(argv[1],"r");
if(pricelist == NULL)
  {
    fprintf(stderr,"error: could not open %s for reading\n",argv[1]);
    exit(1);
  }

/* how many useful lines in the file = total lines - header lines - "total" line */
lines = atoi(argv[2]) - 3;

list = (price_line *)malloc(lines * sizeof(price_line));

if(argc == 4)             /* read a top N value, if present */
  {
    top_n = atoi(argv[3]);
/*     fprintf(stderr,"argv[3]: %s, top_n: %d",argv[3],top_n); */
  }

/* read input file and remember it */

fgets(line,256,pricelist); /* pass the top two lines through */
printf("%s",line);
fgets(line,256,pricelist);
printf("%s",line);

/* read the rest of the file */
for(i=0; i < lines; i++)
  {

    j = 0;
    
    fgets(line,256,pricelist);
#ifdef DEBUG2
    fprintf(stderr,"line: %s",line);
#endif
    
    while(line[j] != ' ' || line[j-1] != ' ') j++; /* advance past card name */
    
    sscanf(line+j,"%f\n", &price); /* snatch the price from the line */

    /* having read the line, add it to the list */
    list[i].price = price;
    list[i].line  = (char *)malloc(strlen(line)+1);
    strcpy(list[i].line, line);
  }

fclose(pricelist);

/* now sort the array */

/* cheezy descending order bubble sort.  
 * hell, i only run this once a month...
 */
for(i = 0; i < lines-1; i++)     /* at least i don't do any more iterations */
  for(j = 0; j < lines-i-1; j++)   /* than necessary for b.s. */
    {
      if(list[j].price < list[j+1].price) /* out of order? */
	{
	  ftemp = list[j].price;       /* swap */
	  list[j].price = list[j+1].price;
	  list[j+1].price = ftemp;

	  ctemp = list[j].line;
	  list[j].line = list[j+1].line;
	  list[j+1].line = ctemp;
	}
    }

/* finally, write out the top N lines */
for(i = 0; i < top_n; i++)
  printf("%s",list[i].line);

exit(0);
}
